Attribute VB_Name = "ID3Module"
Public Type TagData
    tag As String               '^Õo[W
    SongName As String          'Ȗ
    Artist As String            'èĖ
    Album As String             '
    writtenYear As String       '\N
    Comment As String           'Rg
    Category As String          'W
End Type

Public Function GetID3(FileName As String) As TagData
    
    Dim i As Integer
    Dim FileNo As Integer
    Dim tagPosition As Long

'ID3v1
    Dim bufv1(128) As Byte
    Dim getv1Tag(3) As Byte
    Dim getv1SongName(30) As Byte
    Dim getv1Artist(30) As Byte
    Dim getv1Album(30) As Byte
    Dim getv1writtenYear(4) As Byte
    Dim getv1Comment(30) As Byte
    Dim getv1Category As Byte
    
    If FileLen(FileName) > 128 Then
        
        tagPosition = FileLen(FileName) - 127
        FileNo = FreeFile
        Open FileName For Binary As #FileNo
            Seek #FileNo, tagPosition
            For i = 0 To 127
                Get #FileNo, , bufv1(i)
            Next i
        Close #FileNo
        
        For i = 0 To 2
            getv1Tag(i) = bufv1(i)
        Next i
        For i = 3 To 32
            getv1SongName(i - 3) = bufv1(i)
        Next i
        For i = 33 To 62
            getv1Artist(i - 33) = bufv1(i)
        Next i
        For i = 63 To 92
            getv1Album(i - 63) = bufv1(i)
        Next i
        For i = 93 To 96
            getv1writtenYear(i - 93) = bufv1(i)
        Next i
        For i = 97 To 126
            getv1Comment(i - 97) = bufv1(i)
        Next i
            getv1Category = bufv1(127)
            
        If Trim(NTrim(StrConv(getv1Tag(), vbUnicode))) = "TAG" Then
            GetID3.tag = "ID3v1"
            GetID3.SongName = Trim(NTrim(StrConv(getv1SongName(), vbUnicode)))
            GetID3.Artist = Trim(NTrim(StrConv(getv1Artist(), vbUnicode)))
            GetID3.Album = Trim(NTrim(StrConv(getv1Album(), vbUnicode)))
            GetID3.writtenYear = Trim(NTrim(StrConv(getv1writtenYear(), vbUnicode)))
            GetID3.Comment = Trim(NTrim(StrConv(getv1Comment(), vbUnicode)))
            GetID3.Category = CategoryName(CStr(getv1Category))
        Else
            GetID3.tag = "None"
        End If
        
    End If
    
End Function

Public Function PutID3(FileName As String, tag As TagData) As Boolean
On Error GoTo eh

    Dim FileNo As Integer
    Dim tagPosition As Long
    
    Dim Title As String
    Dim Artist As String
    Dim Album As String
    Dim writtenYear As String
    Dim Comments As String
    Dim Genre As Integer
    
    'ݏ񐮗
    Title = SpaceBury(tag.SongName, 30)
    Artist = SpaceBury(tag.Artist, 30)
    Album = SpaceBury(tag.Album, 30)
    writtenYear = SpaceBury(Format(tag.writtenYear, "0000"), 4)
    Comments = SpaceBury(tag.Comment, 30)
    Genre = CategoryNumber(tag.Category)

    '^Ołɂ邩
    If FileLen(FileName) > 128 Then
        
        Dim getv1Tag(3) As Byte
        Dim i As Integer
        FileNo = FreeFile
        Open FileName For Binary As #FileNo
            Seek #FileNo, LOF(FileNo) - 127
            For i = 0 To 2
                Get #FileNo, , getv1Tag(i)
            Next i
        Close #FileNo
        
        If Trim(NTrim(StrConv(getv1Tag(), vbUnicode))) = "TAG" Then
            tagPosition = FileLen(FileName) - 127
        Else
            tagPosition = FileLen(FileName) + 1
        End If
        
    Else
    
        tagPosition = FileLen(FileName) + 1
    
    End If
        
    '
            FileNo = FreeFile
        Open FileName For Binary As #FileNo
            Seek #FileNo, tagPosition
            Put #FileNo, , "TAG"
            Put #FileNo, , Title
            Put #FileNo, , Artist
            Put #FileNo, , Album
            Put #FileNo, , writtenYear
            Put #FileNo, , Comments
            Put #FileNo, , CByte(Genre)
        Close #FileNo
        
        PutID3 = True
    
Exit Function
eh:
    PutID3 = False
End Function

Public Function EraseID3(FileName As String) As Boolean
On Error GoTo eh

    Dim tag As TagData
    tag = GetID3(FileName)
    If tag.tag = "ID3v1" Then
        Dim buf() As Byte
        Dim byteNumber As Long
        Dim byteUnit As Long
        Dim Separate As Integer
        Dim FilePath As String
        Dim File As String
        Dim FileName1 As String
        Dim FileName2 As String
        Dim FileNo1 As Integer
        Dim FileNo2 As Integer
        Dim TempFileName As String
        
        For Separate = 0 To Len(FileName)
            If Mid(FileName, Len(FileName) - Separate, 1) = "\" Then Exit For
        Next Separate
        FilePath = Left(FileName, Len(FileName) - Separate - 1)
        File = Right(FileName, Separate)
        
        FileNo1 = FreeFile(0)
        FileNo2 = FreeFile(1)
        FileName1 = FileName
        FileName2 = FilePath & "\Temp_" & File
        
        Open FileName1 For Binary As #FileNo1
        Open FileName2 For Binary As #FileNo2
            Do While Not LOF(FileNo1) - 128 - byteNumber < 0
                If LOF(FileNo1) - 128 - byteNumber > 65536 Then
                    byteUnit = 65536
                ElseIf LOF(FileNo1) - 128 - byteNumber > 8192 Then
                    byteUnit = 8192
                ElseIf LOF(FileNo1) - 128 - byteNumber > 1024 Then
                    byteUnit = 1024
                ElseIf LOF(FileNo1) - 128 - byteNumber > 128 Then
                    byteUnit = 128
                ElseIf LOF(FileNo1) - 128 - byteNumber > 8 Then
                    byteUnit = 8
                ElseIf LOF(FileNo1) - 128 - byteNumber > 0 Then
                    byteUnit = 1
                End If
                
                ReDim buf(byteUnit)
                
                Get #FileNo1, , buf
                Put #FileNo2, , buf
                
                byteNumber = byteNumber + byteUnit
            Loop
        Close #FileNo1
        Close #FileNo2
        
        
        Dim fs As New FileSystemObject
        Call fs.DeleteFile(FileName1, True)
        Call fs.CopyFile(FileName2, FileName1, True)
        Call fs.DeleteFile(FileName2, True)

    End If
    
    EraseID3 = True
    
eh:
    EraseID3 = False
End Function

Private Function CategoryName(Number As Integer) As String

    Select Case Number
        Case 0
            CategoryName = "u[X"
        Case 1
            CategoryName = "NVbNbN"
        Case 2
            CategoryName = "Jg["
        Case 3
            CategoryName = "_X"
        Case 4
            CategoryName = "fBXR"
        Case 5
            CategoryName = "t@N"
        Case 6
            CategoryName = "OW"
        Case 7
            CategoryName = "qbvzbv"
        Case 8
            CategoryName = "WY"
        Case 9
            CategoryName = "^"
        Case 10
            CategoryName = "j[GCW"
        Case 11
            CategoryName = "I[fB[Y"
        Case 12
            CategoryName = "̑"
        Case 13
            CategoryName = "|bvX"
        Case 14
            CategoryName = "R&B"
        Case 15
            CategoryName = "bv"
        Case 16
            CategoryName = "QG"
        Case 17
            CategoryName = "bN"
        Case 18
            CategoryName = "eNm"
        Case 19
            CategoryName = "C_XgA"
        Case 20
            CategoryName = "I^ieB"
        Case 21
            CategoryName = "XJ"
        Case 22
            CategoryName = "fX^"
        Case 23
            CategoryName = "vNX"
        Case 24
            CategoryName = "TEhgbN"
        Case 25
            CategoryName = "[eNm"
        Case 26
            CategoryName = "ArGg"
        Case 27
            CategoryName = "gbvzbv"
        Case 28
            CategoryName = "H[J"
        Case 29
            CategoryName = "WY+t@N"
        Case 30
            CategoryName = "t[W"
        Case 31
            CategoryName = "gX"
        Case 32
            CategoryName = "NVJ"
        Case 33
            CategoryName = "CXgD^"
        Case 34
            CategoryName = "AVbh"
        Case 35
            CategoryName = "nEX"
        Case 36
            CategoryName = "Q["
        Case 37
            CategoryName = "TEhNbv"
        Case 38
            CategoryName = "SXy"
        Case 39
            CategoryName = "mCY"
        Case 40
            CategoryName = "A^ibN"
        Case 41
            CategoryName = "x[X"
        Case 42
            CategoryName = "\E"
        Case 43
            CategoryName = "pN"
        Case 44
            CategoryName = "Xy[X"
        Case 45
            CategoryName = "fBeCeBu"
        Case 46
            CategoryName = "CXg|bv"
        Case 47
            CategoryName = "CXgbN"
        Case 48
            CategoryName = "GXjbN"
        Case 49
            CategoryName = "SVbN"
        Case 50
            CategoryName = "_[NEFCu"
        Case 51
            CategoryName = "eNmEC_XgA"
        Case 52
            CategoryName = "GNgjbN"
        Case 53
            CategoryName = "|bvEtH[N"
        Case 54
            CategoryName = "[_X"
        Case 55
            CategoryName = "h["
        Case 56
            CategoryName = "TUbN"
        Case 57
            CategoryName = "RfB"
        Case 58
            CategoryName = "Jg"
        Case 59
            CategoryName = "KOX^"
        Case 60
            CategoryName = "gbv40"
        Case 61
            CategoryName = "NX`bv"
        Case 62
            CategoryName = "WO"
        Case 63
            CategoryName = "lCeBuAJ"
        Case 64
            CategoryName = "[_X"
        Case 65
            CategoryName = "Jobg"
        Case 66
            CategoryName = "j[EFCu"
        Case 67
            CategoryName = "TCPfbN"
        Case 68
            CategoryName = "Cu"
        Case 69
            CategoryName = "V[gD["
        Case 70
            CategoryName = "g[["
        Case 71
            CategoryName = "[t@C"
        Case 72
            CategoryName = "gCo"
        Case 73
            CategoryName = "AVbhpN"
        Case 74
            CategoryName = "AVbhWY"
        Case 75
            CategoryName = "|J"
        Case 76
            CategoryName = "g"
        Case 77
            CategoryName = "~[WJ"
        Case 78
            CategoryName = "bN["
        Case 79
            CategoryName = "n[hbN"
        Case 80
            CategoryName = "tH[N"
        Case 81
            CategoryName = "tH[N/bN"
        Case 82
            CategoryName = "iVitH[N"
        Case 83
            CategoryName = "XEBO"
        Case 84
            CategoryName = "t@[Xgt[W"
        Case 85
            CategoryName = "Bedob"
        Case 86
            CategoryName = "e"
        Case 87
            CategoryName = "oCo"
        Case 88
            CategoryName = "PeBbN"
        Case 89
            CategoryName = "u[OX"
        Case 90
            CategoryName = "AoMh"
        Case 91
            CategoryName = "SVbNbN"
        Case 92
            CategoryName = "vObVubN"
        Case 93
            CategoryName = "TCPfbNbN"
        Case 94
            CategoryName = "VtHjbNbN"
        Case 95
            CategoryName = "X[bN"
        Case 96
            CategoryName = "rbNoh"
        Case 97
            CategoryName = "R[X"
        Case 98
            CategoryName = "C[W[XjO"
        Case 99
            CategoryName = "AR[XeBbN"
        Case 100
            CategoryName = "[A"
        Case 101
            CategoryName = "Xs[`V\"
        Case 102
            CategoryName = "V\"
        Case 103
            CategoryName = "Iy"
        Case 104
            CategoryName = "`o[~[WbN"
        Case 105
            CategoryName = "\i^"
        Case 106
            CategoryName = "VtHj["
        Case 107
            CategoryName = "u[eBx[X"
        Case 108
            CategoryName = "vX"
        Case 109
            CategoryName = "|mO[u"
        Case 110
            CategoryName = "T^CA["
        Case 111
            CategoryName = "X[W"
        Case 112
            CategoryName = "Nu"
        Case 113
            CategoryName = "^S"
        Case 114
            CategoryName = "To"
        Case 115
            CategoryName = "tH[NA"
        Case 116
            CategoryName = "o[h"
        Case 117
            CategoryName = "p[o[h"
        Case 118
            CategoryName = "Y~bN\E"
        Case 119
            CategoryName = "t[X^C"
        Case 120
            CategoryName = "fGbg"
        Case 121
            CategoryName = "pNbN"
        Case 122
            CategoryName = "h\"
        Case 123
            CategoryName = "AJy"
        Case 124
            CategoryName = "[nEX"
        Case 125
            CategoryName = "_Xz["
        Case 126
            CategoryName = "SA"
        Case 127
            CategoryName = "hx[X"
        Case 128
            CategoryName = "NunEX"
        Case 129
            CategoryName = "n[hRA"
        Case 130
            CategoryName = "e["
        Case 131
            CategoryName = "CfB["
        Case 132
            CategoryName = "ubg|bv"
        Case 133
            CategoryName = "NegerpN"
        Case 134
            CategoryName = "PolskpN"
        Case 135
            CategoryName = "r[g"
        Case 136
            CategoryName = "NX`KOX^bv"
        Case 137
            CategoryName = "wr[^"
        Case 138
            CategoryName = "ubN^"
        Case 139
            CategoryName = "NXI[o["
        Case 140
            CategoryName = "Re|[NX`"
        Case 141
            CategoryName = "NX`bN"
        Case 142
            CategoryName = "KC"
        Case 143
            CategoryName = "TT"
        Case 144
            CategoryName = "XbV^"
        Case 145
            CategoryName = "Aj"
        Case 146
            CategoryName = "i|bv"
        Case 147
            CategoryName = "VX|bv"
        Case 251
            CategoryName = "D"
        Case 252
            CategoryName = "eNmAr[g"
        Case 253
            CategoryName = "GG"
        Case 254
            CategoryName = "B"
        Case 255
            CategoryName = "Aj"
        Case Else
            CategoryName = "s"
    End Select
    
End Function

Private Function CategoryNumber(Name As String) As Integer

    Select Case Name
        Case "u[X"
            CategoryNumber = 0
        Case "NVbNbN"
            CategoryNumber = 1
        Case "Jg["
            CategoryNumber = 2
        Case "_X"
            CategoryNumber = 3
        Case "fBXR"
            CategoryNumber = 4
        Case "t@N"
            CategoryNumber = 5
        Case "OW"
            CategoryNumber = 6
        Case "qbvzbv"
            CategoryNumber = 7
        Case "WY"
            CategoryNumber = 8
        Case "^"
            CategoryNumber = 9
        Case "j[GCW"
            CategoryNumber = 10
        Case "I[fB[Y"
            CategoryNumber = 11
        Case "̑"
            CategoryNumber = 12
        Case "|bvX"
            CategoryNumber = 13
        Case "R&B"
            CategoryNumber = 14
        Case "bv"
            CategoryNumber = 15
        Case "QG"
            CategoryNumber = 16
        Case "bN"
            CategoryNumber = 17
        Case "eNm"
            CategoryNumber = 18
        Case "C_XgA"
            CategoryNumber = 19
        Case "I^ieB"
            CategoryNumber = 20
        Case "XJ"
            CategoryNumber = 21
        Case "fX^"
            CategoryNumber = 22
        Case "vNX"
            CategoryNumber = 23
        Case "TEhgbN"
            CategoryNumber = 24
        Case "[eNm"
            CategoryNumber = 25
        Case "ArGg"
            CategoryNumber = 26
        Case "gbvzbv"
            CategoryNumber = 27
        Case "H[J"
            CategoryNumber = 28
        Case "WY+t@N"
            CategoryNumber = 29
        Case "t[W"
            CategoryNumber = 30
        Case "gX"
            CategoryNumber = 31
        Case "NVJ"
            CategoryNumber = 32
        Case "CXgD^"
            CategoryNumber = 33
        Case "AVbh"
            CategoryNumber = 34
        Case "nEX"
            CategoryNumber = 35
        Case "Q["
            CategoryNumber = 36
        Case "TEhNbv"
            CategoryNumber = 37
        Case "SXy"
            CategoryNumber = 38
        Case "mCY"
            CategoryNumber = 39
        Case "A^ibN"
            CategoryNumber = 40
        Case "x[X"
            CategoryNumber = 41
        Case "\E"
            CategoryNumber = 42
        Case "pN"
            CategoryNumber = 43
        Case "Xy[X"
            CategoryNumber = 44
        Case "fBeCeBu"
            CategoryNumber = 45
        Case "CXg|bv"
            CategoryNumber = 46
        Case "CXgbN"
            CategoryNumber = 47
        Case "GXjbN"
            CategoryNumber = 48
        Case "SVbN"
            CategoryNumber = 49
        Case "_[NEFCu"
            CategoryNumber = 50
        Case "eNmEC_XgA"
            CategoryNumber = 51
        Case "GNgjbN"
            CategoryNumber = 52
        Case "|bvEtH[N"
            CategoryNumber = 53
        Case "[_X"
            CategoryNumber = 54
        Case "h["
            CategoryNumber = 55
        Case "TUbN"
            CategoryNumber = 56
        Case "RfB"
            CategoryNumber = 57
        Case "Jg"
            CategoryNumber = 58
        Case "KOX^"
            CategoryNumber = 59
        Case "gbv40"
            CategoryNumber = 60
        Case "NX`bv"
            CategoryNumber = 61
        Case "WO"
            CategoryNumber = 62
        Case "lCeBuAJ"
            CategoryNumber = 63
        Case "[_X"
            CategoryNumber = 64
        Case "Jobg"
            CategoryNumber = 65
        Case "j[EFCu"
            CategoryNumber = 66
        Case "TCPfbN"
            CategoryNumber = 67
        Case "Cu"
            CategoryNumber = 68
        Case "V[gD["
            CategoryNumber = 69
        Case "g[["
            CategoryNumber = 70
        Case "[t@C"
            CategoryNumber = 71
        Case "gCo"
            CategoryNumber = 72
        Case "AVbhpN"
            CategoryNumber = 73
        Case "AVbhWY"
            CategoryNumber = 74
        Case "|J"
            CategoryNumber = 75
        Case "g"
            CategoryNumber = 76
        Case "~[WJ"
            CategoryNumber = 77
        Case "bN["
            CategoryNumber = 78
        Case "n[hbN"
            CategoryNumber = 79
        Case "tH[N"
            CategoryNumber = 80
        Case "tH[N/bN"
            CategoryNumber = 81
        Case "iVitH[N"
            CategoryNumber = 82
        Case "XEBO"
            CategoryNumber = 83
        Case "t@[Xgt[W"
            CategoryNumber = 84
        Case "Bedob"
            CategoryNumber = 85
        Case "e"
            CategoryNumber = 86
        Case "oCo"
            CategoryNumber = 87
        Case "PeBbN"
            CategoryNumber = 88
        Case "u[OX"
            CategoryNumber = 89
        Case "AoMh"
            CategoryNumber = 90
        Case "SVbNbN"
            CategoryNumber = 91
        Case "vObVubN"
            CategoryNumber = 92
        Case "TCPfbNbN"
            CategoryNumber = 93
        Case "VtHjbNbN"
            CategoryNumber = 94
        Case "X[bN"
            CategoryNumber = 95
        Case "rbNoh"
            CategoryNumber = 96
        Case "R[X"
            CategoryNumber = 97
        Case "C[W[XjO"
            CategoryNumber = 98
        Case "AR[XeBbN"
            CategoryNumber = 99
        Case "[A"
            CategoryNumber = 100
        Case "Xs[`V\"
            CategoryNumber = 101
        Case "V\"
            CategoryNumber = 102
        Case "Iy"
            CategoryNumber = 103
        Case "`o[~[WbN"
            CategoryNumber = 104
        Case "\i^"
            CategoryNumber = 105
        Case "VtHj["
            CategoryNumber = 106
        Case "u[eBx[X"
            CategoryNumber = 107
        Case "vX"
            CategoryNumber = 108
        Case "|mO[u"
            CategoryNumber = 109
        Case "T^CA["
            CategoryNumber = 110
        Case "X[W"
            CategoryNumber = 111
        Case "Nu"
            CategoryNumber = 112
        Case "^S"
            CategoryNumber = 113
        Case "To"
            CategoryNumber = 114
        Case "tH[NA"
            CategoryNumber = 115
        Case "o[h"
            CategoryNumber = 116
        Case "p[o[h"
            CategoryNumber = 117
        Case "Y~bN\E"
            CategoryNumber = 118
        Case "t[X^C"
            CategoryNumber = 119
        Case "fGbg"
            CategoryNumber = 120
        Case "pNbN"
            CategoryNumber = 121
        Case "h\"
            CategoryNumber = 122
        Case "AJy"
            CategoryNumber = 123
        Case "[nEX"
            CategoryNumber = 124
        Case "_Xz["
            CategoryNumber = 125
        Case "SA"
            CategoryNumber = 126
        Case "hx[X"
            CategoryNumber = "127"
        Case "NunEX"
            CategoryNumber = 128
        Case "n[hRA"
            CategoryNumber = 129
        Case "e["
            CategoryNumber = 130
        Case "CfB["
            CategoryNumber = 131
        Case "ubg|bv"
            CategoryNumber = 132
        Case "NegerpN"
            CategoryNumber = 133
        Case "PolskpN"
            CategoryNumber = 134
        Case "r[g"
            CategoryNumber = 135
        Case "NX`KOX^bv"
            CategoryNumber = 136
        Case "wr[^"
            CategoryNumber = 137
        Case "ubN^"
            CategoryNumber = 138
        Case "NXI[o["
            CategoryNumber = 139
        Case "Re|[NX`"
            CategoryNumber = 140
        Case "NX`bN"
            CategoryNumber = 141
        Case "KC"
            CategoryNumber = 142
        Case "TT"
            CategoryNumber = 143
        Case "XbV^"
            CategoryNumber = 144
        Case "Aj"
            CategoryNumber = 145
        Case "i|bv"
            CategoryNumber = 146
        Case "VX|bv"
            CategoryNumber = 147
        Case "D"
            CategoryNumber = 251
        Case "eNmAr[g"
            CategoryNumber = 252
        Case "GG"
            CategoryNumber = 253
        Case "B"
            CategoryNumber = 254
'        Case "Aj"
'            CategoryNumber = 255
        Case Else
            CategoryNumber = 12
    End Select
    
End Function

'---------------------------------------------------------
'֐FFunction NTrim()
'@\F\0 ȍ~̕폜
'FWord  : ϊ
'߂lFϊ㕶
'---------------------------------------------------------
Private Function NTrim(Word As String) As String
    If InStr(Word, Chr(0)) > 0 Then
        NTrim = Left(Word, InStr(Word, Chr(0)) - 1)
    Else
        NTrim = Word
    End If
End Function

'---------------------------------------------------------
'֐FFunction SpaceBury
'@\Fw肵byte܂ŃXy[XŖ߂,zĂꍇ͉E[؂
'FWord  : ϊ, Number  : byte
'߂lFϊ㕶
'---------------------------------------------------------
Private Function SpaceBury(Word As String, Number As Integer) As String
    
    Dim WordByte As Integer
    Dim i, j As Integer
    WordByte = 0
    For i = 1 To Len(Word)
        If Hex(AscB(MidB(Word, i * 2, 1))) = 0 Then
            WordByte = WordByte + 1
            If WordByte = Number Then
                SpaceBury = Left(Word, i)
                Exit Function
            End If
        Else
            WordByte = WordByte + 2
            If WordByte = Number Then
                SpaceBury = Left(Word, i)
                Exit Function
            ElseIf WordByte = Number + 1 Then
                SpaceBury = Left(Word, i - 1) & Chr(0)
                Exit Function
            End If
        End If
        
    Next i
    
    If WordByte < Number Then
        For j = 1 To Number - WordByte
            Word = Word & Chr(0)
        Next j
    End If
    
    SpaceBury = Word
    
End Function
